#  Copyright (c) 2008 Red Hat, Inc.

#  There is no URL or upstream source entry as this package constitutes
#  upstream for itself.

Summary: Infiniband/iWARP Kernel Module Initializer
Name: rdma
Version: 3.10
Release: 3.0.22%{?dist}
License: GPLv2+
Group: System Environment/Base
Source0: rdma.conf
Source1: rdma.init
Source2: rdma.fixup-mtrr.awk
Source3: rdma.rules
Source4: rdma.ifup-ib
Source5: rdma.ifdown-ib
Source6: rdma.nfs-rdma.init
Source7: rdma.mlx4_vnic-net.rules
Source8: rdma.connectx_port_config
Source9: rdma.cx_virt_config.py
Source10: rdma.ib_ipoib.conf
Source11: rdma.ib_sdp.conf
Source12: rdma.mlx4_en.conf
Source13: rdma.ibdev2netdev
Source14: rdma.mlx4_vnic_bond.sh
Source15: rdma.mlx4_vnic_confd
Source16: rdma.mlx4_vnic_info
Source17: rdma.mlx4_vnicd
Source18: rdma.sysctl_perf_tuning
Source19: modprobe-rdma-mlx4.conf
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch
Requires(post): chkconfig
Requires(preun): chkconfig
Requires: udev >= 145
%description 
User space initialization scripts for the Oracle UEK2 kernel InfiniBand/iWARP drivers

%prep

%build

%install
rm -rf %{buildroot}
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/%{name}
install -d %{buildroot}%{_sysconfdir}/modprobe.d
install -d %{buildroot}/lib/udev/rules.d
install -d %{buildroot}%{_sysconfdir}/sysconfig/network-scripts
install -d %{buildroot}%{_sysconfdir}/modprobe.d
install -d %{buildroot}/lib/udev
install -d %{buildroot}/sbin
install -d %{buildroot}/%{_bindir}

install -m 0644 %{SOURCE0} %{buildroot}%{_sysconfdir}/%{name}/%{name}.conf
install -m 0644 %{SOURCE19} %{buildroot}%{_sysconfdir}/modprobe.d/rdma-mlx4.conf
install -m 0755 %{SOURCE1} %{buildroot}%{_initrddir}/%{name}
install -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/%{name}/fixup-mtrr.awk
install -m 0644 %{SOURCE3} %{buildroot}/lib/udev/rules.d/90-infiniband.rules
install -m 0755 %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/ifup-ib
install -m 0755 %{SOURCE5} %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/ifdown-ib
install -m 0755 %{SOURCE6} %{buildroot}%{_initrddir}/nfs-rdma
install -m 0644 %{SOURCE7} %{buildroot}/lib/udev/rules.d/71-mlx4_vnic-net.rules
install -m 0755 %{SOURCE8} %{buildroot}/sbin/connectx_port_config
install -m 0755 %{SOURCE9} %{buildroot}/sbin/cx_virt_config.py
install -m 0644 %{SOURCE10} %{buildroot}%{_sysconfdir}/modprobe.d/ib_ipoib.conf
install -m 0644 %{SOURCE11} %{buildroot}%{_sysconfdir}/modprobe.d/ib_sdp.conf
install -m 0644 %{SOURCE12} %{buildroot}%{_sysconfdir}/modprobe.d/mlx4_en.conf
install -m 0755 %{SOURCE13} %{buildroot}/%{_bindir}/ibdev2netdev
install -m 0755 %{SOURCE14} %{buildroot}/lib/udev/mlx4_vnic_bond.sh
install -m 0755 %{SOURCE15} %{buildroot}%{_initrddir}/mlx4_vnic_confd
install -m 0755 %{SOURCE16} %{buildroot}/sbin/mlx4_vnic_info
install -m 0755 %{SOURCE17} %{buildroot}/sbin/mlx4_vnicd
install -m 0755 %{SOURCE18} %{buildroot}/sbin/sysctl_perf_tuning
touch %{buildroot}%{_sysconfdir}/%{name}/connectx.conf

%clean
rm -rf %{buildroot}

%post
if [ $1 = 1 ]; then
    /sbin/chkconfig --add %{name}
fi

%preun
if [ $1 = 0 ]; then
    /sbin/chkconfig --del %{name}
fi

%files
%defattr(-,root,root,-)
%dir %{_sysconfdir}/%{name}
%{_sysconfdir}/modprobe.d/rdma-mlx4.conf
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/connectx.conf
%{_sysconfdir}/%{name}/fixup-mtrr.awk
%{_initrddir}/%{name}
%{_initrddir}/mlx4_vnic_confd
%{_initrddir}/nfs-rdma
%{_sysconfdir}/sysconfig/network-scripts/ifup-ib
%{_sysconfdir}/sysconfig/network-scripts/ifdown-ib
/lib/udev/rules.d/90-infiniband.rules
/lib/udev/rules.d/71-mlx4_vnic-net.rules                            
%{_sysconfdir}/modprobe.d/ib_ipoib.conf                                       
%{_sysconfdir}/modprobe.d/ib_sdp.conf                                         
%{_sysconfdir}/modprobe.d/mlx4_en.conf                                        
/lib/udev/mlx4_vnic_bond.sh
/usr/bin/ibdev2netdev
/sbin/connectx_port_config
/sbin/cx_virt_config.py
/sbin/mlx4_vnic_info
/sbin/mlx4_vnicd
/sbin/sysctl_perf_tuning

%changelog
* Thu Jan 14 2016 Zhigang Wang <zhigang.x.wang@oracle.com> 3.10-3.0.22
- remove the consistency state [orabug 22502854]

* Wed Dec 9 2015 Qing Huang <qing.huang@oracle.com>
- Forward port orabug 20669249
- Forward port orabug 21372841
- Forward port orabug 19150870
- Add code in start() function to prevent rdma script from reloading all
  the drivers because systemd replaces SysVinit in OL7 and it replaces
  restart() with one stop() and one start() calls. [orabug 21862427]

* Fri Sep 11 2015 Qing Huang <qing.huang@oracle.com> - 3.10-3.0.21
- use a dedicated log file for rdma init script to save logging data as we cannot
  use "logger" program before rsyslog service gets started. 
  [orabug 21787428]
- workaround for delayed vm event handling in dom0 which causes VF interfaces
  to stay in down state in vm(s) after a soft reboot [orabug 21028539]
- imagetool bin exe path fix for EXD [orabug 21787452]
- imagetool bin exe path fix for BDA [orabug 21787471]
- Set "MLX4_XEN_FMR_LOAD=yes" and "MLX4_VNIC_LOAD=yes" in rdma.conf per BDA request
  (reverse changes made in *.15, so *.21 and *.14 would have the same default settings)
  [orabug 21787521]

* Tue Sep 01 2015 Wengang Wang <wen.gang.wang@oracle.com> - 3.10-3.0.20
- detect existing RDMA applications [orabug 20843819 ]

* Tue Jun 11 2015 Wengang Wang <wen.gang.wang@oracle.com> - 3.10-3.0.19
- remove error logs [orabug 21215197]

* Fri Mar 13 2015 Chien Yen <chien.yen@oracle.com>  - 3.10-3.0.15
- Add OVM support for ODA and BDA
- Set "MLX4_XEN_FMR_LOAD=no" and "MLX4_VNIC_LOAD=no" in rdma.conf
- Orabug 20643875
- Make stop/restart NOP because of 20048920 and 19665303 [orabug 20543899]
- update rdma.connectx_port_config to detect the MLX pci [orabug 20543874]

* Tue Dec 23 2014 Chien Yen <chien.yen@oracle.com>  - 3.10-3.0.14
- Fixed rdma.cx_virt_config.py for OVS 3.2.9

* Mon Nov 21 2014 Chien Yen <chien.yen@oracle.com>  - 3.10-3.0.13
- added sleep 2 to wait_for_hca_hotplugging() in rdma.init

* Mon Nov 17 2014 Chien Yen <chien.yen@oracle.com>  - 3.10-3.0.12
- Get num_hca from dom0 using ovmapi if the script runs in domU

* Tue Nov 11 2014 Chien Yen <chien.yen@oracle.com>  - 3.10-3.0.11
- Orabug 19789352 - perform PCI rescan in rdma init script if it is run in a VM

* Mon Nov 10 2014 Mukesh Kacker <mukesh.kacker@oracle.com>  - 3.10-3.0.10
- Fix bash syntax error (missing space between != operator and arg)
  [ Orabug 19978449 ]

* Tue Oct 13 2014 Yuval Shaia <yuval.shaia@oracle.com> - 3.10-3.0.9
- Orabug 19519645
- Add support to enable ACL in ifcfg-ib* files

* Fri Oct 03 2014 Chien Yen <chien.yen@oracle.com> - 3.10-3.0.8
- Orabug 19615057
- Fixed rdma.connectx_port_config for multiple HCAs.

* Thu Sep 04 2014 Mukesh Kacker <mukesh.kacker@oracle.com>  - 3.10-3.0.7
- Implement handling of user generated device name for pkey devices using
  new create_named_child interface in ipoib [ Orabug: 19477360 ]
- Fix bug in unset invocation for bond MASTER/SLAVE variables
  [ Orabug 19524450 ]

* Wed Jun 25 2014 Mukesh Kacker <mukesh.kacker@oracle.com> - 3.10-3.0.6
- CATCHUP with openibd bugfixes in OL5 (Details below)
  Orabug: 19137471 
- Move mlx4 alias in rdma to rdma.mlx4_en.conf
  (OL5 orabug 16859554, partial openibd 4.0.4)
- load rds_rdma after bringing up the IB interfaces
  (OL5 orabug 16789580, openibd 4.0.5 and openibd 4.0.6)
- Addm mlx4_en to blacklist to prevent warning message load mlx4_en
  (OL5 orabug 13815605, openibd 4.0.7)
- Change openib init script to support "alias rds rds_rdma" in modprobe
  (openibd 4.0.10 and 4.0.11)
- Fix get_interfaces() in openib.init for supporting multiple HCAs (openibd 4.0.12)
- Add echo to unload_module() [ openibd 4.0.13 and openibd 4.0.14 ]
- openibd needs to wait for interfaces in ifconfig with async ib module init
  (OL5 Orabug: 18483921; openibd 4.0.16)
- Set default HCA mode to IB (openibd 4.0.18)

* Sun Jun 22 2014 Mukesh Kacker <mukesh.kacker@oracle.com> - 3.10-3.0.5
- Run sysctl.conf in start() so arp response settings in place before IP live on IB interfaces.
- Orabug: 18400003

* Wed May 14 2014 Chien Yen <chien.yen@oracle.com> - 3.10-3.0.4
- Remove loading of iw_cxgb3 and iw_cxgb4 from rdma.init

* Mon Apr 28 2014 Chien Yen <chien.yen@oracle.com> - 3.10-3.0.3
- Check the script is run on dom0 or domU for loading FMR
- Orabug 18562276

* Sun Dec 1 2013 Chien Yen <chien.yen@oracle.com> - 3.10-3.0.2
- Include mlx4 driver in rdma.conf
- Change conf dir for mlx4_vnic_confd and connectx_port_config too /etc/rdma

* Tue Oct 15 2013 Joe Jin <joe.jin@oracle.com> - 3.10-3.0.1
- Append mlx4_* module parameters when insmod the modules [orabug 17429249] (Joe Jin)
- Delay load mlx4_* to prevent hung when start udev. [orabug 16897608] (Joe Jin)
- Fix FMR load, persistent ib0 subinterfaces, remove kudzu dependency (Chien Yen)
- Add SDP to rdma.conf and rdma.init (Chien Yen)
- Support Mellanox OFED 1.5.5 (Chien Yen)

* Wed Aug 07 2013 Doug Ledford <dledford@redhat.com> - 3.10-3
- Replace an errant usage of PARENTDEVICE with PHYSDEV in ifdown-ib
- Related: bz990288

* Wed Aug 07 2013 Doug Ledford <dledford@redhat.com> - 3.10-2
- Somehow during editing I accidentally deleted a single character from
  the post scriptlet.  rpmdiff caught it, now I'm fixing it.
- Resolves: bz990288

* Tue Jul 23 2013 Doug Ledford <dledford@redhat.com> - 3.10-1
- Bump version to match final kernel submission
- Add support for P_Key interfaces to ifup-ib and ifdown-ib

* Sun Oct 14 2012 Doug Ledford <dledford@redhat.com> - 3.6-1
- Bump version to match final kernel submission

* Fri Sep 14 2012 Doug Ledford <dledford@redhat.com> - 3.6-0.rc5.1
- Bump version to match kernel update submitted for rhel6.4

* Fri Aug 24 2012 Doug Ledford <dledford@redhat.com> - 3.3-4
- Fix an issue in the ifup-ib script
- Fix a problem with the setting of infiniband dev perms
- Resolves: bz834428

* Thu Apr 26 2012 Doug Ledford <dledford@redhat.com> - 3.3-3
- The fix to bug 808600 was noisy and resulted in bug 815999,
  silence the script
- Resolves: bz815999

* Tue Apr 24 2012 Doug Ledford <dledford@redhat.com> - 3.3-2
- Unload the iw_cxgb4 module when stopping the rdma stack
- Related: bz815622

* Tue Apr 24 2012 Doug Ledford <dledford@redhat.com> - 3.3-1
- Fix an issue in the rdma script that caused rds_rdma to load
  when it shouldn't
- Resolves: bz815622

* Thu Apr 05 2012 Doug Ledford <dledford@redhat.com> - 1.0-21
- Don't change the user's directory on interactive runs
- Related: bz808600

* Thu Apr 05 2012 Doug Ledford <dledford@redhat.com> - 1.0-20
- Name the cards slightly differently (upstream request)
- Check for the ibacm program before trying to down the stack
- Resolves: bz808600

* Thu Mar 22 2012 Doug Ledford <dledford@redhat.com> - 1.0-19
- Remove the rules file again, issue turned out to be a kernel bug.
- Related: bz739138

* Wed Mar 21 2012 Doug Ledford <dledford@redhat.com> - 1.0-18
- Resurrect rules file, some of the IB devices are not created by the
  kernel
- Related: bz739138

* Fri Mar 09 2012 Doug Ledford <dledford@redhat.com> - 1.0-17
- Don't do lsmod in the %%post script looking for ib_ipoib, anaconda
  loads it unconditionally.  Instead, anaconda has been modified to
  enable our init script if it installed over an IPoIB interface, so
  simply remove that portion of our %%post script.
- Related: bz739138

* Tue Feb 28 2012 Doug Ledford <dledford@redhat.com> - 1.0-16
- If we are being installed on a machine that has ib_ipoib module loaded,
  then this is likely because it is a machine being installed over IPoIB,
  so enable our init script
- Related: bz739138

* Tue Feb 28 2012 Doug Ledford <dledford@redhat.com> - 1.0-15
- No longer provide a rules file to create infinband devices, the kernel
  now creates them in the proper place all by itself
- Change the LSB headers in the init script, they were wrong
- Related: bz739138

* Tue Oct 25 2011 Doug Ledford <dledford@redhat.com> - 1.0-14
- Clear the umask before loading kernel modules otherwise the kernel
  modules inherit our umask and don't create the /dev/infiniband
  files with the proper permissions.
- Resolves: bz748087

* Wed Oct 19 2011 Doug Ledford <dledford@redhat.com> - 1.0-13
- Default to not loading the RDS stack by default as it has some known
  issues at the moment.
- Resolves: bz747378

* Thu Aug 11 2011 Doug Ledford <dledford@redhat.com> - 1.0-12
- Another minor fix to RDS support in the rdma script
- Related: bz725016

* Thu Aug 04 2011 Doug Ledford <dledford@redhat.com> - 1.0-11
- Minor fix to RDS support in the rdma init script
- Related: bz725016

* Thu Aug 04 2011 Doug Ledford <dledford@redhat.com> - 1.0-10
- Fix ifup-ib script to be compatible with change to core function
  expand_config
- Fix renaming of ib? devices to the name given in the ifcfg-* file
- Fix the fact that once you down the rdma stack and reload it, the
  HWADDR line in ifcfg-* files no longer matches the address of the
  ports.  We now match only on the part of the HWADDR that doesn't
  change.
- Fix rdma init script to know about cxgb4 adapters
- Fix rdma init script to find all InfiniBand interfaces whether they
  use an ib? name or a custom name
- Fix rdma init script to down all InfiniBand interfaces on rdma shutdown
  regardless of interface name
- Fix rdma init script to find all ifcfg-* files that apply to ipoib
  interfaces without requiring that they be named ib?
- Fix rdma init script to know to unload ib_qib module on stop
- Add an ifdown-ib file that fixes the HWADDR not matching on the second
  or later times you down the rdma subsystem
- Related: bz725016
- Resolves: bz678947, bz721101

* Tue Aug 17 2010 Doug Ledford <dledford@redhat.com> - 1.0-9
- Minor tweak to rdma init script to do the udevadm trigger command in two
  seperate calls since we can no longer match on the same item twice and
  have the command succeed for both match types.
- Resolves: bz612234

* Wed Aug 04 2010 Doug Ledford <dledford@redhat.com> - 1.0-8
- Update udev rules syntax to eliminate warnings emitted via syslog (bz603264)
- Add new init script for starting/stopping nfs over rdma support
- Require that the nfs-rdma service be down before stopping the rdma
  service (bz613437)
- Change ifup-ib to properly account for the fact that the [ test program
  does not process tests in order and fail immediately on first failing
  test, resulting in error messages due to unquoted environment variables
  that don't need quoting in the second test due to the fact that the
  first test guarantees they exist.  Or that's how things should be, but
  they aren't, so rewrite tests to accommodate this fact. (bz612284)
- Use ip instead of ifconfig as ifconfig knows it doesn't handle infinband
  hardware addresses properly (even though we don't care, we aren't using
  it for that) and prints out copious warning messages (bz613086)
- Related: bz612284, bz613086

* Wed May 26 2010 Doug Ledford <dledford@redhat.com> - 1.0-7
- Require a version of udev that's known to contain udevadm and support
  usage of udevadm trigger and udevadm settle
- Update rdma.init to use the proper udev commands
- Resolves: bz586594

* Tue Dec 01 2009 Doug Ledford <dledford@redhat.com> - 1.0-6
- Tweak init script for LSB compliance
- Tweak ifup-ib script to work properly with bonded slaves that need their
  MTU set
- Tweak ifup-ib script to properly change connected mode either on or off
  instead of only setting it on but not turning it off if the setting changes

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Oct 09 2008 Doug Ledford <dledford@redhat.com> - 1.0-3
- Add the ifup-ib script so we support connected mode on ib interfaces

* Mon Jun 09 2008 Doug Ledford <dledford@redhat.com> - 1.0-2
- Attempt to use --subsystem-match=infiniband in the rdma init script use
  of udevtrigger so we don't trigger the whole system
- Add a requirement to stop opensm to the init script

* Sun Jun 08 2008 Doug Ledford <dledford@redhat.com> - 1.0-1
- Create an initial package for Fedora review

